/******************************************************************************
 * The following code was generated by the mental mill(R)                     *
 * Fx_code_generator build 110260.6433 21 May 2010 nt-x86                     *  
 *                                                                            *
 * Portions Copyright (c) 1986-2010 mental images GmbH, Berlin, Germany.      *
 ******************************************************************************/

/*
	add_default_states : true
	alpha_transparency : true
	annotation_map : default.axml
	depth_test : true
	depth_write : true
	face_forward : false
	flip_tex2d_v : false
	format : HLSL
	fragment_shader_profile : ps_4_0
	generate_sampler_states : true
	generate_samplers : true
	generate_umapped_annotations : false
	hlsl_sas_conformance : true
	internal_space : camera
	rotate_cube_map : false
	shader_type : surface
	two_sided : false
	use_oit : false
	vertex_shader_profile : vs_4_0
	vertex_stream_space : object
	vs_binding_binormal : BINORMAL
	vs_binding_tangent : TANGENT
*/

// shader type surface

//
// The state structure is used internally within the fragment shader to
// commonly used values.
//
struct State
{
	float3 position;
	float3 origin;
	float3 normal;
	float3 direction;
	float ray_length;
	float light_distance;
};

//
// Values for the light_type parameter of light shaders
//
#define LIGHT_POINT    0
#define LIGHT_SPOT     1
#define LIGHT_INFINITE 2
#define LIGHT_PLANAR   3

//
// The light iterator structure holds the return values resulting from
// evaluating a light.
//
#ifndef __LIGHT_ITERATOR_STRUCT
#define __LIGHT_ITERATOR_STRUCT
struct Light_iterator {
    float3 msl_point;
    float3 msl_direction;
    float  msl_distance;
    float  msl_dot_nl;
    float3 msl_contribution;
    float3 msl_raw_contribution;
    float3 msl_shadow;
    int    msl_count;
};
#endif // __LIGHT_ITERATOR_STRUCT

//
// Ray
//
struct Ray {
    float3 msl_origin;
    float3 msl_direction;
};

bool Ray_equal(Ray a,Ray b) {
    return all(a.msl_origin == b.msl_origin)
        && all(a.msl_direction == b.msl_direction);
}

Ray __Ray_ctor(float3 o, float3 d)
{
    Ray r;
    r.msl_origin = o;
    r.msl_direction = d;
    return r;
}

float2 __float2_ctor(float v)
{
	return v.xx;
}

float3 __float3_ctor(float v)
{
	return v.xxx;
}

float4 __float4_ctor(float v)
{
	return v.xxxx;
}

struct Trace_options
{
	int ray_type;
	bool enable_environment;
};

Trace_options __Trace_options_ctor(
	int ray_type,
	bool enable_environment)
{
	Trace_options to;
	to.ray_type = ray_type;
	to.enable_environment = enable_environment;
	return to;
}


//
// Scale parameter for ddx and ddy calls
//
uniform float __differential_scale = 1.0;

#ifndef __TEXTURE_LOOKUP
#define __TEXTURE_LOOKUP

#endif // __TEXTURE_LOOKUP

void __make_basis(const float3 n, const float3 u, const float3 v,
        out float3 t, out float3 b)
{
    b = normalize(cross(u,n));
    t = cross(n,b);
    if (dot(b,v) < 0.0)  b = -b;
}

float3 __perspective_divide(float4 pt)
{
    return pt.xyz/pt.w;
}

// 
// State dependant variable recalculation. 
// 
void __update_state_origin_or_position(inout State state) 
{ 
    state.direction = state.position - state.origin; 
    state.ray_length = length(state.direction); 
    state.direction = normalize(state.direction); 
} 

uniform int __object_label = 0; 
// 
// Encoding of Renderer::label internal state (int) as float4. 
// 
float4 _label_as_color() 
{ 
    int n = __object_label; 
    float4 c; 
    c.a = float(n / 16777216); 
    c.b = float((n % 16777216) / 65536); 
    c.g = float((n % 65536) / 256); 
    c.r = float(n % 256); 
    c /= 255.0;
    return c; 
} 

uniform float4 __clip_plane = float4(1, 1, 0, 0);


//
// The following are free parameters of the shader
// that should be set by the application at runtime.
//
float4 msl_Light_point_1_color
<
	string UIName = "Color";
	string UIWidget = "Color";
> = float4(1.000000f, 1.000000f, 1.000000f, 1.000000f);
float msl_Light_point_1_intensity
<
	string UIName = "Intensity";
	float UIMin = 0.000000f;
	float UIMax = 10.000000f;
	float UIStep = 0.01;
	string UIWidget = "slider";
> = 3.141593f;
float msl_Light_point_1_distance_falloff_exponent
<
	string UIName = "Distance Falloff Exponent";
	float UIMin = 0.000000f;
	float UIMax = 4.000000f;
	float UIStep = 0.01;
	string UIWidget = "slider";
> = 0.000000f;
float msl_Light_point_1_distance_scale
<
	string UIName = "Distance Scale";
	float UIMin = 0.001000f;
	float UIMax = 2.000000f;
	float UIStep = 0.01;
	string UIWidget = "slider";
> = 1.000000f;


//
// The following are parameters representing non-varying state variables 
// referenced by the shader. These should be set by the application at runtime.
// Note that vector parameters should be provided in camera space.
//
float4x4 __object_to_ndc : WorldViewProjection
<
	string UIWidget = "none";
>;
bool __orthographic : Orthographic= false;
float4x4 __object_to_world : World
<
	string UIWidget = "none";
>;
float4x4 __object_to_camera : WorldView
<
	string UIWidget = "none";
>;
float4x4 __camera_to_world : ViewInverse
<
	string UIWidget = "none";
>;
float4x4 __camera_to_object : WorldViewInverse
<
	string UIWidget = "none";
>;
//                                                   
// The following are parameters representing non-varying non-state variables      
// referenced by the shader. These should be set by the application at runtime.             
//                                                   
float4x4 __internal_to_light;
float4x4 __light_to_internal;



//
// The App2vert structure defines the vertex attributes used by the vertex
// shader. The application should supply a vertex stream containing these 
// elements.
//
struct App2vert
{
	float3 position : POSITION;
	float3 normal : NORMAL;
};

//
// The Vert2frag_out structure defines values output by the vertex shader.
//
struct Vert2frag_out
{
	float4 hpos : POSITION;
	float3 position : TEXCOORD0;
	float3 normal : TEXCOORD1;
};

//
// The Vert2frag_in structure defines values used by the fragment shader.
//
struct Vert2frag_in
{
	float4 hpos : POSITION;
	float3 position : TEXCOORD0;
	float3 normal : TEXCOORD1;
};

//
// This function is the main method of the vertex shader.
//
Vert2frag_out vertex_main(
	App2vert vs_in)
{
	Vert2frag_out vs_out;
	float4 position = float4(vs_in.position, 1);
	vs_out.hpos = mul(position, __object_to_ndc);
	vs_out.position = mul(position, __object_to_camera).xyz;
	vs_out.normal = mul((float3x3)__camera_to_object, vs_in.normal);
	return vs_out;
}

//
// Declaration of final output type. For MRT, this is a struct.
//
typedef float4 FS_OUT;

// 
// The following functions are generated from the MetaSL implementation
// of the shaders that are part of the compiled shader graph.
// 

void Light_point_main(
	inout State state,
	float4 msl_color,
	float msl_intensity,
	float msl_distance_falloff_exponent,
	float msl_distance_scale,
	out float4 msl_result,
	out float4 msl_light_shadow)
{
	{
		float msl_attenuation = 1.000000f;
		if (msl_distance_falloff_exponent > (float(0)))
		{
			msl_attenuation = (pow(((state.light_distance) * msl_distance_scale), (-msl_distance_falloff_exponent)));
		}
		msl_result = ((msl_color * msl_intensity) * msl_attenuation);
		msl_result.a = 1.000000f;
		msl_light_shadow = float4((float3(1.0,1.0,1.0)),1.0);
	}
}

//
// The following method is the root function of the shader graph
//
float4 Light_point_1_eval(State state, out FS_OUT eval_out)
{
	// primary_out: 
	float4 msl_result;
	float4 msl_light_shadow;
	Light_point_main(state, msl_Light_point_1_color, msl_Light_point_1_intensity, msl_Light_point_1_distance_falloff_exponent, msl_Light_point_1_distance_scale, msl_result, msl_light_shadow);
	msl_result.a = 1.0;
	eval_out = float4(msl_result);
	return float4(msl_result);
}

//
// This function is the main method of the fragment shader. It initializes the
// values in the state structure that are used by nodes in the shader graph
// and produces the final result of the shader.
//
FS_OUT fragment_main(
	Vert2frag_in fs_in) : COLOR
{
	State state;
	state.position = fs_in.position;
	state.normal = normalize(fs_in.normal);
	state.origin = __orthographic ? float3(state.position.x, state.position.y, 0) : 0;
	state.ray_length = __orthographic ? abs(state.position.z) : length(state.position);
	state.direction = __orthographic ? float3(0,0,-1) : state.position/state.ray_length;
	state.light_distance = 0;

	FS_OUT eval_out;  // multiple shader outputs
	float4 primary_out;  // primary shader output
	primary_out = Light_point_1_eval(state, eval_out);
	FS_OUT fs_out;
	fs_out = primary_out;
	return fs_out;
}

//
// The following define the default technique and pass of the effect.
//
technique T0
{
	pass P0
	{
		ZEnable      = true;
		ZWriteEnable = true;
		CullMode     = none;
		VertexShader = compile vs_4_0 vertex_main();
		PixelShader  = compile ps_4_0 fragment_main();
	}
}

