﻿using System;
using System.Collections.Generic;

using System.Text;

using ChaosEngine.EngineCore.Graph;
using ChaosEngine.EngineCore.Graph.Logics;
namespace ChaosEngine.EngineCore
{
    public static class Factory
    {
        public static class Node{
            public static TransformNode Transform(TransformNode p,string name){
                return new TransformNode(name, p);
            }
            public static TransformNode Mesh(TransformNode p,string name,int maxVert,int maxTri){
                TransformNode r = new TransformNode(name, p);
                r.AddLogic(new MeshData(maxVert, maxTri));
                r.AddLogic(new MeshRenderer());
                return r;
            }
            public static TransformNode FromLogic(string name,TransformNode p,dynamic logic){
                TransformNode r = new TransformNode(name, p);
                r.AddLogic(logic);
                return r;
            }
        }
    }
}
